'<SCRIPT LANGUAGE="VBScript">
Option Explicit

'-------------------------------------------------------------------------
' spoofdetectSink.vbs
'
' Description: Checks the FROM Address against a domain list 
' If sender ist part, than add XMessageFlag for Warnings
'
' Runtime Errors are not handled
'
' (c)2006 Frank Carius. www.msxfaq.de
'
' Version 1.0 (16. Aug 2006) Frank Carius
'
' Should be installed on any "incoming" Mailserver
'-------------------------------------------------------------------------
'
Const CDO_RUN_NEXT_SINK = 0
Const logfile = "C:\spoofdetectSink\spoofdetectSink.log"
Const Loglevel = 5
'Const LOCALDOMAINS = "msxfaq.local;msxfaq.de;"   ' Das letzte Semikolon ist wichtig !!

'
' OnArrival sink entry point
'
Sub ISMTPOnArrival_OnArrival(ByVal Msg, EventStatus)
''    On Error Resume Next

	Dim mail, Fields, xmessageflag, strfrom

	AppendLog "----- SMTPFromSink START -----", 4
	AppendLog "-- load Message Properties", 5
	Set Fields = msg.Fields
	xmessageflag = Fields("urn:schemas:mailheader:x-message-flag").value
	AppendLog " msg.from    :" & msg.from, 5
	AppendLog " msg.to      :" & msg.to, 5
	AppendLog " msg.subject :" & msg.subject, 5
	AppendLog " xmessageflag:" & xmessageflag, 4

	AppendLog "-- Processing FROM", 4
	strFrom  = msg.from
	AppendLog " FROM: " & strFrom  , 5
	if instr(strfrom,"@msxfaq.de>") > 0 then
		AppendLog " Result: SPOOFING", 5
		Fields("urn:schemas:mailheader:x-message-flag") = "Achtung: Absenderadresse vermutlich gefaelscht"
		AppendLog "  SAVE modifications", 4
		Fields.update
		Msg.Datasource.Save  ' save changes to the mail
	else
		AppendLog " Result: no Spoofing", 5
	end if 

	AppendLog "-- SMTPFromSink END -----", 4
	EventStatus = CDO_RUN_NEXT_SINK
End Sub




Sub AppendLog(strLog, errlevel)
'Fgt einen Eintrag in die Log-Datei ein
	Dim file, fs

	if loglevel>=errlevel then
		Set fs = CreateObject("Scripting.FileSystemObject")
		Set file = fs.OpenTextFile(logfile, 8, true)
		file.Write(Now & ",")
		select case errlevel
			case 1	file.Write("Fatal Line" & err.Source)
			case 2	file.Write("Error")
			case 3	file.Write("Warning")
			case 4	file.Write("Information")
			case 5	file.Write("Debug")
			case else file.Write("Code:"&errlevel)
		end select
		file.WriteLine("," & strLog)
		file.Close
	end if
End Sub

'</SCRIPT>